;<ff
Window frmMain, 3, 0, 'TForm', 'Tiny GUI application using TForm', $16080000, $0, 0, 339, 199, 320, 240, MainFormWinProc;
Window NONE, 0, 0, 'BUTTON', 'Button', $50000000, $0, 0, 96, 40, 64, 25, 0;
Window NONE, 0, 0, 'STATIC', 'Label', $50001200, $0, 101, 136, 88, 80, 16, 0;
Window NONE, 0, 0, 'STATIC', 'Result:', $50000000, $0, 0, 136, 72, 88, 16, 0;
Window NONE, 0, 0, 'STATIC', 'Time [ms]', $50000000, $0, 0, 16, 72, 88, 16, 0;
Window NONE, 2, 0, 'STATIC', 'Label', $50001200, $0, 100, 16, 88, 80, 16, 0;
;ff>
uglobal
  pointer dd ?
endg



proc StrProc1, .ptr

begin
        push    edi ecx

        xor     eax, eax
        or      ecx, -1
        mov     edi, [.ptr]

        repnz scasb

        not     ecx
        dec     ecx
        mov     eax, ecx

        pop     ecx edi
        return
endp



proc StrProc2, .ptr
begin
        mov     eax, [.ptr]

.loop:
        cmp     byte [eax], 0
        lea     eax, [eax+1]
        jne     .loop

        stc
        sbb     eax, [.ptr]
        return
endp




proc StrProc3, .ptr
begin
        push    ebx ecx edx esi edi

        mov     edi, $7f7f7f7f
        mov     ecx, $80808080

        mov     esi, [.ptr]

.scan:
        mov     eax, [esi]
        mov     edx, [esi+4]

        and     eax, edi
        and     edx, edi

        add     eax, edi
        add     edx, edi

        or      eax, [esi]
        or      edx, [esi+4]

        and     eax, ecx
        and     edx, ecx

        and     eax, edx
        add     esi, 8

        cmp     eax, ecx
        je      .scan

.found:
        lea     eax, [esi-9]

; so search by bytes
.byteloop:
        lea     eax, [eax+1]
        cmp     byte [eax], 0
        jne     .byteloop

        sub     eax, [.ptr]

        pop     edi esi edx ecx ebx
        return
endp





proc StrProc4, .pString
begin
        mov     eax, [.pString]
.scan:
        cmp     dword [eax], 0
        lea     eax, [eax+4]
        jne     .scan

        lea     eax, [eax-4]

; so search back
.byteloop:
        lea     eax, [eax-1]
        cmp     byte [eax], 0
        je      .byteloop

        lea     eax, [eax+1]
        sub     eax, [.pString]
        return
endp




proc StrProc5, .ptr
begin
        push    edx esi

        mov     esi, [.ptr]
.scan:
        mov     eax, [esi]
        mov     edx, [esi+4]

        and     eax, $7f7f7f7f
        and     edx, $7f7f7f7f

        add     eax, $7f7f7f7f
        add     edx, $7f7f7f7f

        or      eax, [esi]
        or      edx, [esi+4]

        and     eax, $80808080
        and     edx, $80808080

        and     eax, edx
        add     esi, 8

        cmp     eax, $80808080
        je      .scan

        lea     eax, [esi-9]

; so search by bytes
.byteloop:
        lea     eax, [eax+1]
        cmp     byte [eax], 0
        jne     .byteloop

        sub     eax, [.ptr]

        pop     esi edx
        return
endp


proc StrProc6, .ptr
begin
        push    ecx edx esi edi

        mov     eax, [.ptr]
.scan:
        mov     ecx, [eax]
        mov     edx, [eax+4]

        lea     eax, [eax+8]

        lea     esi, [ecx-$01010101]
        lea     edi, [edx-$01010101]

        not     ecx
        not     edx

        and     esi, ecx
        and     edi, edx

        and     esi, $80808080
        and     edi, $80808080

        or      esi, edi
        jz      .scan

        sub     eax, 9

; byte 0 was found: so search by bytes.
.byteloop:
        lea     eax, [eax+1]
        cmp     byte [eax], 0
        jne     .byteloop

        sub     eax, [.ptr]

        pop     edi esi edx ecx
        return
endp



proc StrProc7, .ptr
begin
        push    ebx ecx

        mov     eax, [.ptr]

.scan:
        mov     ebx, [eax]
        lea     eax, [eax+4]

        lea     ecx, [ebx-$01010101]
        not     ebx
        and     ecx, ebx
        and     ecx, $80808080
        jz      .scan

        lea     eax, [eax-5]

; so search by bytes
.byteloop:
        inc     eax
        cmp     byte [eax], 0
        jne     .byteloop

        sub     eax, [.ptr]

        pop     ecx ebx
        return
endp












winproc MainFormWinProc
begin


ondefault
        stc
        return




onmessage WM_COMMAND

        invoke  GetProcessHeap
        invoke  HeapAlloc, eax, HEAP_ZERO_MEMORY, 1000000

        mov     [pointer], eax

        mov     edi, eax
        mov     ecx, 985000 / 4
        or      eax, -1

        rep stosd
        mov     ecx, 29
        rep stosb


        invoke  GetTickCount
        push    eax

        mov     ecx, 1000

.loop1:
        stdcall StrProc7, [pointer]
        loop    .loop1

        pop     ebx
        push    eax

        invoke  GetTickCount
        sub     eax, ebx

        stdcall SetNumber, [.hwnd], 100, eax

        pop     eax
        stdcall SetNumber, [.hwnd], 101, eax

        invoke  GetProcessHeap
        invoke  HeapFree, eax, 0, [pointer]

        clc
        return


endwp





proc SetNumber, .hwnd, .id, .number
begin
        pushad

        stdcall NumToStr, [.number], 0, 0, ntsDec or ntsUnsigned or ntsZeroTerminated
        push    eax
        stdcall StrPtr, eax
        invoke  SendDlgItemMessage, [.hwnd], [.id], WM_SETTEXT, 0, eax
        stdcall StrDel ; from the stack

        popad
        return
endp



