; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "Fresh artistic license."         |
;|_______________________________________________________________________________________|
;
;  Description: shell32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto shell32,  \
    Activate_RunDLL, N, <NONE>,  'Activate_RunDLL',  \
    AppCompat_RunDLL, W, <NONE>,  'AppCompat_RunDLLW',  \
    CDefFolderMenu_Create, N, <NONE>,  'CDefFolderMenu_Create',  \
    CDefFolderMenu_Create2, N, <NONE>,  'CDefFolderMenu_Create2',  \
    CallCPLEntry16, N, <NONE>,  'CallCPLEntry16',  \
    CheckEscapes, A, <NONE>,  'CheckEscapesA',  \
    CheckEscapes, W, <NONE>,  'CheckEscapesW',  \
    CommandLineToArgv, W, <.lpCmdLine, .pNumArgs>,  'CommandLineToArgvW',  \
    Control_FillCache_RunDLL, A, <NONE>,  'Control_FillCache_RunDLLA',  \
    Control_FillCache_RunDLL, W, <NONE>,  'Control_FillCache_RunDLLW',  \
    Control_RunDLL, A, <NONE>,  'Control_RunDLLA',  \
    Control_RunDLLAsUser, W, <NONE>,  'Control_RunDLLAsUserW',  \
    Control_RunDLL, W, <NONE>,  'Control_RunDLLW',  \
    DAD_AutoScroll, N, <NONE>,  'DAD_AutoScroll',  \
    DAD_DragEnterEx, N, <NONE>,  'DAD_DragEnterEx',  \
    DAD_DragEnterEx2, N, <NONE>,  'DAD_DragEnterEx2',  \
    DAD_DragLeave, N, <NONE>,  'DAD_DragLeave',  \
    DAD_DragMove, N, <NONE>,  'DAD_DragMove',  \
    DAD_SetDragImage, N, <NONE>,  'DAD_SetDragImage',  \
    DAD_ShowDragImage, N, <NONE>,  'DAD_ShowDragImage',  \
    DllCanUnloadNow, N, <VOID>,  'DllCanUnloadNow',  \
    DllGetClassObject, N, <.rclsid, .riid, .ppv>,  'DllGetClassObject',  \
\;    DllGetVersion, N, <NONE>,  'DllGetVersion',  \
\;    DllInstall, N, <.bInstall, .pszCmdLine>,  'DllInstall',  \
    DllRegisterServer, N, <VOID>,  'DllRegisterServer',  \
    DllUnregisterServer, N, <VOID>,  'DllUnregisterServer',  \
    DoEnvironmentSubst, A, <.szString, .cbString>,  'DoEnvironmentSubstA',  \
    DoEnvironmentSubst, W, <.szString, .cbString>,  'DoEnvironmentSubstW',  \
    DragAcceptFiles, N, <.hwnd, .fAccept>,  'DragAcceptFiles',  \
    DragFinish, N, <.hDrop>,  'DragFinish',  \
    DragQueryFile, A, <.HDROP, .UINT, .lpStr, .ch>,  'DragQueryFileA',  \
    DragQueryFile, W, <.HDROP, .UINT, .lpStr, .ch>,  'DragQueryFileW',  \
    DragQueryFileAorW, N, <NONE>,  'DragQueryFileAorW',  \
    DragQueryPoint, N, <.HDROP, .lpPoint>,  'DragQueryPoint',  \
    DriveType, N, <NONE>,  'DriveType',  \
    DuplicateIcon, N, <.hInst, .hIcon>,  'DuplicateIcon',  \
    ExtractAssociatedIcon, A, <.hInst, .lpIconPath, .lpiIcon>,  'ExtractAssociatedIconA',  \
    ExtractAssociatedIconEx, A, <NONE>,  'ExtractAssociatedIconExA',  \
    ExtractAssociatedIconEx, W, <NONE>,  'ExtractAssociatedIconExW',  \
    ExtractAssociatedIcon, W, <.hInst, .lpIconPath, .lpiIcon>,  'ExtractAssociatedIconW',  \
    ExtractIcon, A, <.hInst, .lpszExeFileName, .nIconIndex>,  'ExtractIconA',  \
    ExtractIconEx, A, <.lpszFile, .nIconIndex, .phiconLarge, .phiconSmall, .nIcons>,  'ExtractIconExA',  \
    ExtractIconEx, W, <.lpszFile, .nIconIndex, .phiconLarge, .phiconSmall, .nIcons>,  'ExtractIconExW',  \
    ExtractIconResInfo, A, <NONE>,  'ExtractIconResInfoA',  \
    ExtractIconResInfo, W, <NONE>,  'ExtractIconResInfoW',  \
    ExtractIcon, W, <.hInst, .lpszExeFileName, .nIconIndex>,  'ExtractIconW',  \
    ExtractVersionResource16, W, <NONE>,  'ExtractVersionResource16W',  \
    FindExeDlgProc, N, <NONE>,  'FindExeDlgProc',  \
    FindExecutable, A, <.lpFile, .lpDirectory, .lpResult>,  'FindExecutableA',  \
    FindExecutable, W, <.lpFile, .lpDirectory, .lpResult>,  'FindExecutableW',  \
    FreeIconList, N, <NONE>,  'FreeIconList',  \
    GetFileNameFromBrowse, N, <NONE>,  'GetFileNameFromBrowse',  \
    ILAppendID, N, <NONE>,  'ILAppendID',  \
    ILClone, N, <NONE>,  'ILClone',  \
    ILCloneFirst, N, <NONE>,  'ILCloneFirst',  \
    ILCombine, N, <NONE>,  'ILCombine',  \
    ILCreateFromPath, A, <NONE>,  'ILCreateFromPathA',  \
    ILCreateFromPath, W, <NONE>,  'ILCreateFromPathW',  \
    ILFindChild, N, <NONE>,  'ILFindChild',  \
    ILFindLastID, N, <NONE>,  'ILFindLastID',  \
    ILFree, N, <NONE>,  'ILFree',  \
    ILGetNext, N, <NONE>,  'ILGetNext',  \
    ILGetSize, N, <NONE>,  'ILGetSize',  \
    ILIsEqual, N, <NONE>,  'ILIsEqual',  \
    ILIsParent, N, <NONE>,  'ILIsParent',  \
    ILLoadFromStream, N, <NONE>,  'ILLoadFromStream',  \
    ILRemoveLastID, N, <NONE>,  'ILRemoveLastID',  \
    ILSaveToStream, N, <NONE>,  'ILSaveToStream',  \
    InternalExtractIconList, A, <NONE>,  'InternalExtractIconListA',  \
    InternalExtractIconList, W, <NONE>,  'InternalExtractIconListW',  \
    IsLFNDrive, A, <NONE>,  'IsLFNDriveA',  \
    IsLFNDrive, W, <NONE>,  'IsLFNDriveW',  \
    IsNetDrive, N, <NONE>,  'IsNetDrive',  \
    IsUserAnAdmin, N, <NONE>,  'IsUserAnAdmin',  \
    OpenAs_RunDLL, A, <NONE>,  'OpenAs_RunDLLA',  \
    OpenAs_RunDLL, W, <NONE>,  'OpenAs_RunDLLW',  \
    OpenRegStream, N, <NONE>,  'OpenRegStream',  \
    Options_RunDLL, A, <NONE>,  'Options_RunDLLA',  \
    Options_RunDLL, W, <NONE>,  'Options_RunDLLW',  \
    PathCleanupSpec, N, <NONE>,  'PathCleanupSpec',  \
    PathGetShortPath, N, <NONE>,  'PathGetShortPath',  \
    PathIsExe, N, <NONE>,  'PathIsExe',  \
    PathIsSlow, A, <NONE>,  'PathIsSlowA',  \
    PathIsSlow, W, <NONE>,  'PathIsSlowW',  \
    PathMakeUniqueName, N, <NONE>,  'PathMakeUniqueName',  \
    PathProcessCommand, N, <NONE>,  'PathProcessCommand',  \
    PathQualify, N, <NONE>,  'PathQualify',  \
    PathResolve, N, <NONE>,  'PathResolve',  \
    PathYetAnotherMakeUniqueName, N, <NONE>,  'PathYetAnotherMakeUniqueName',  \
    PickIconDlg, N, <NONE>,  'PickIconDlg',  \
    PifMgr_CloseProperties, N, <NONE>,  'PifMgr_CloseProperties',  \
    PifMgr_GetProperties, N, <NONE>,  'PifMgr_GetProperties',  \
    PifMgr_OpenProperties, N, <NONE>,  'PifMgr_OpenProperties',  \
    PifMgr_SetProperties, N, <NONE>,  'PifMgr_SetProperties',  \
    PrintersGetCommand_RunDLL, A, <NONE>,  'PrintersGetCommand_RunDLLA',  \
    PrintersGetCommand_RunDLL, W, <NONE>,  'PrintersGetCommand_RunDLLW',  \
    ReadCabinetState, N, <NONE>,  'ReadCabinetState',  \
    RealDriveType, N, <NONE>,  'RealDriveType',  \
    RealShellExecute, A, <NONE>,  'RealShellExecuteA',  \
    RealShellExecuteEx, A, <NONE>,  'RealShellExecuteExA',  \
    RealShellExecuteEx, W, <NONE>,  'RealShellExecuteExW',  \
    RealShellExecute, W, <NONE>,  'RealShellExecuteW',  \
    RegenerateUserEnvironment, N, <NONE>,  'RegenerateUserEnvironment',  \
    RestartDialog, N, <NONE>,  'RestartDialog',  \
    RestartDialogEx, N, <NONE>,  'RestartDialogEx',  \
    SHAddFromPropSheetExtArray, N, <NONE>,  'SHAddFromPropSheetExtArray',  \
    SHAddToRecentDocs, N, <.uFlags, .pv>,  'SHAddToRecentDocs',  \
    SHAlloc, N, <NONE>,  'SHAlloc',  \
    SHAllocShared, N, <NONE>,  'SHAllocShared',  \
    SHAppBarMessage, N, <.dwMessage, .pData>,  'SHAppBarMessage',  \
    SHBindToParent, N, <.pidl, .riid, .ppv, .ppidlLast>,  'SHBindToParent',  \
    SHBrowseForFolder, A, <.lpbi>,  'SHBrowseForFolderA',  \
    SHBrowseForFolder, W, <.lpbi>,  'SHBrowseForFolderW',  \
    SHCLSIDFromString, N, <NONE>,  'SHCLSIDFromString',  \
    SHChangeNotification_Lock, N, <NONE>,  'SHChangeNotification_Lock',  \
    SHChangeNotification_Unlock, N, <NONE>,  'SHChangeNotification_Unlock',  \
    SHChangeNotify, N, <.wEventId, .uFlags, .dwItem1, .dwItem2>,  'SHChangeNotify',  \
    SHChangeNotifyDeregister, N, <NONE>,  'SHChangeNotifyDeregister',  \
    SHChangeNotifyRegister, N, <NONE>,  'SHChangeNotifyRegister',  \
    SHChangeNotifySuspendResume, N, <NONE>,  'SHChangeNotifySuspendResume',  \
    SHCloneSpecialIDList, N, <NONE>,  'SHCloneSpecialIDList',  \
    SHCoCreateInstance, N, <NONE>,  'SHCoCreateInstance',  \
    SHCreateDirectory, N, <NONE>,  'SHCreateDirectory',  \
    SHCreateDirectoryEx, A, <.hwnd, .pszPath, .psa>,  'SHCreateDirectoryExA',  \
    SHCreateDirectoryEx, W, <.hwnd, .pszPath, .psa>,  'SHCreateDirectoryExW',  \
    SHCreateFileExtractIcon, W, <NONE>,  'SHCreateFileExtractIconW',  \
    SHCreateLocalServerRunDll, N, <NONE>,  'SHCreateLocalServerRunDll',  \
    SHCreateProcessAsUser, W, <NONE>,  'SHCreateProcessAsUserW',  \
    SHCreatePropSheetExtArray, N, <NONE>,  'SHCreatePropSheetExtArray',  \
    SHCreateQueryCancelAutoPlayMoniker, N, <NONE>,  'SHCreateQueryCancelAutoPlayMoniker',  \
    SHCreateShellFolderView, N, <NONE>,  'SHCreateShellFolderView',  \
    SHCreateShellFolderViewEx, N, <NONE>,  'SHCreateShellFolderViewEx',  \
    SHCreateShellItem, N, <NONE>,  'SHCreateShellItem',  \
    SHCreateStdEnumFmtEtc, N, <NONE>,  'SHCreateStdEnumFmtEtc',  \
    SHDefExtractIcon, A, <NONE>,  'SHDefExtractIconA',  \
    SHDefExtractIcon, W, <NONE>,  'SHDefExtractIconW',  \
    SHDestroyPropSheetExtArray, N, <NONE>,  'SHDestroyPropSheetExtArray',  \
    SHDoDragDrop, N, <NONE>,  'SHDoDragDrop',  \
    SHEmptyRecycleBin, A, <.hwnd, .pszRootPath, .dwFlags>,  'SHEmptyRecycleBinA',  \
    SHEmptyRecycleBin, W, <.hwnd, .pszRootPath, .dwFlags>,  'SHEmptyRecycleBinW',  \
    SHEnableServiceObject, N, <NONE>,  'SHEnableServiceObject',  \
    SHEnumerateUnreadMailAccounts, W, <NONE>,  'SHEnumerateUnreadMailAccountsW',  \
    SHExtractIcons, W, <NONE>,  'SHExtractIconsW',  \
    SHFileOperation, A, <.lpFileOp>,  'SHFileOperationA',  \
    SHFileOperation, W, <.lpFileOp>,  'SHFileOperationW',  \
    SHFindFiles, N, <NONE>,  'SHFindFiles',  \
    SHFind_InitMenuPopup, N, <NONE>,  'SHFind_InitMenuPopup',  \
    SHFlushClipboard, N, <NONE>,  'SHFlushClipboard',  \
    SHFlushSFCache, N, <NONE>,  'SHFlushSFCache',  \
    SHFormatDrive, N, <NONE>,  'SHFormatDrive',  \
    SHFree, N, <NONE>,  'SHFree',  \
    SHFreeNameMappings, N, <.hNameMappings>,  'SHFreeNameMappings',  \
    SHFreeShared, N, <NONE>,  'SHFreeShared',  \
    SHGetAttributesFromDataObject, N, <NONE>,  'SHGetAttributesFromDataObject',  \
    SHGetDataFromIDList, A, <.psf, .pidl, .nFormat, .pv, .cb>,  'SHGetDataFromIDListA',  \
    SHGetDataFromIDList, W, <.psf, .pidl, .nFormat, .pv, .cb>,  'SHGetDataFromIDListW',  \
    SHGetDesktopFolder, N, <.ppshf>,  'SHGetDesktopFolder',  \
    SHGetDiskFreeSpace, A, <NONE>,  'SHGetDiskFreeSpaceA',  \
    SHGetDiskFreeSpaceEx, A, <.pszDirectoryName, .pulFreeBytesAvailableToCaller, .pulTotalNumberOfBytes, .pulTotalNumberOfFreeBytes>,  'SHGetDiskFreeSpaceExA',  \
    SHGetDiskFreeSpaceEx, W, <.pszDirectoryName, .pulFreeBytesAvailableToCaller, .pulTotalNumberOfBytes, .pulTotalNumberOfFreeBytes>,  'SHGetDiskFreeSpaceExW',  \
    SHGetFileInfo, A, <.pszPath, .dwFileAttributes, .psfi, .cbFileInfo, .uFlags>,  'SHGetFileInfoA',  \
    SHGetFileInfo, W, <.pszPath, .dwFileAttributes, .psfi, .cbFileInfo, .uFlags>,  'SHGetFileInfoW',  \
    SHGetFolderLocation, N, <.hwnd, .csidl, .hToken, .dwFlags, .ppidl>,  'SHGetFolderLocation',  \
    SHGetFolderPath, A, <.hwnd, .csidl, .hToken, .dwFlags, .pszPath>,  'SHGetFolderPathA',  \
    SHGetFolderPathAndSubDir, A, <NONE>,  'SHGetFolderPathAndSubDirA',  \
    SHGetFolderPathAndSubDir, W, <NONE>,  'SHGetFolderPathAndSubDirW',  \
    SHGetFolderPath, W, <.hwnd, .csidl, .hToken, .dwFlags, .pszPath>,  'SHGetFolderPathW',  \
    SHGetIconOverlayIndex, A, <.pszIconPath, .iIconIndex>,  'SHGetIconOverlayIndexA',  \
    SHGetIconOverlayIndex, W, <.pszIconPath, .iIconIndex>,  'SHGetIconOverlayIndexW',  \
    SHGetImageList, N, <NONE>,  'SHGetImageList',  \
    SHGetInstanceExplorer, N, <.ppunk>,  'SHGetInstanceExplorer',  \
    SHGetMalloc, N, <.ppMalloc>,  'SHGetMalloc',  \
    SHGetNewLinkInfo, A, <.pszLinkto, .pszDir, .pszName, .pfMustCopy, .uFlags>,  'SHGetNewLinkInfoA',  \
    SHGetNewLinkInfo, W, <.pszLinkto, .pszDir, .pszName, .pfMustCopy, .uFlags>,  'SHGetNewLinkInfoW',  \
    SHGetPathFromIDList, A, <.pidl, .pszPath>,  'SHGetPathFromIDListA',  \
    SHGetPathFromIDList, W, <.pidl, .pszPath>,  'SHGetPathFromIDListW',  \
    SHGetRealIDL, N, <NONE>,  'SHGetRealIDL',  \
    SHGetSetFolderCustomSettings, W, <NONE>,  'SHGetSetFolderCustomSettingsW',  \
    SHGetSetSettings, N, <NONE>,  'SHGetSetSettings',  \
    SHGetSettings, N, <.lpsfs, .dwMask>,  'SHGetSettings',  \
    SHGetShellStyleHInstance, N, <NONE>,  'SHGetShellStyleHInstance',  \
    SHGetSpecialFolderLocation, N, <.hwnd, .csidl, .ppidl>,  'SHGetSpecialFolderLocation',  \
    SHGetSpecialFolderPath, A, <.hwnd, .pszPath, .csidl, .fCreate>,  'SHGetSpecialFolderPathA',  \
    SHGetSpecialFolderPath, W, <.hwnd, .pszPath, .csidl, .fCreate>,  'SHGetSpecialFolderPathW',  \
    SHGetUnreadMailCount, W, <NONE>,  'SHGetUnreadMailCountW',  \
    SHHandleUpdateImage, N, <NONE>,  'SHHandleUpdateImage',  \
    SHHelpShortcuts_RunDLL, A, <NONE>,  'SHHelpShortcuts_RunDLLA',  \
    SHHelpShortcuts_RunDLL, W, <NONE>,  'SHHelpShortcuts_RunDLLW',  \
    SHILCreateFromPath, N, <NONE>,  'SHILCreateFromPath',  \
    SHInvokePrinterCommand, A, <.hwnd, .uAction, .lpBuf1, .lpBuf2, .fModal>,  'SHInvokePrinterCommandA',  \
    SHInvokePrinterCommand, W, <.hwnd, .uAction, .lpBuf1, .lpBuf2, .fModal>,  'SHInvokePrinterCommandW',  \
    SHIsFileAvailableOffline, N, <.pwszPath, .pdwStatus>,  'SHIsFileAvailableOffline',  \
    SHLimitInputEdit, N, <NONE>,  'SHLimitInputEdit',  \
    SHLoadInProc, N, <.rclsid>,  'SHLoadInProc',  \
    SHLoadNonloadedIconOverlayIdentifiers, N, <VOID>,  'SHLoadNonloadedIconOverlayIdentifiers',  \
    SHLoadOLE, N, <NONE>,  'SHLoadOLE',  \
    SHLockShared, N, <NONE>,  'SHLockShared',  \
    SHMapIDListToImageListIndexAsync, N, <NONE>,  'SHMapIDListToImageListIndexAsync',  \
    SHMapPIDLToSystemImageListIndex, N, <NONE>,  'SHMapPIDLToSystemImageListIndex',  \
    SHMultiFileProperties, N, <NONE>,  'SHMultiFileProperties',  \
    SHObjectProperties, N, <NONE>,  'SHObjectProperties',  \
    SHOpenFolderAndSelectItems, N, <NONE>,  'SHOpenFolderAndSelectItems',  \
    SHOpenPropSheet, W, <NONE>,  'SHOpenPropSheetW',  \
    SHParseDisplayName, N, <NONE>,  'SHParseDisplayName',  \
    SHPathPrepareForWrite, A, <.hwnd, .punkEnableModless, .pszPath, .dwFlags>,  'SHPathPrepareForWriteA',  \
    SHPathPrepareForWrite, W, <.hwnd, .punkEnableModless, .pszPath, .dwFlags>,  'SHPathPrepareForWriteW',  \
    SHPropStgCreate, N, <NONE>,  'SHPropStgCreate',  \
    SHPropStgReadMultiple, N, <NONE>,  'SHPropStgReadMultiple',  \
    SHPropStgWriteMultiple, N, <NONE>,  'SHPropStgWriteMultiple',  \
    SHQueryRecycleBin, A, <.pszRootPath, .pSHQueryRBInfo>,  'SHQueryRecycleBinA',  \
    SHQueryRecycleBin, W, <.pszRootPath, .pSHQueryRBInfo>,  'SHQueryRecycleBinW',  \
    SHReplaceFromPropSheetExtArray, N, <NONE>,  'SHReplaceFromPropSheetExtArray',  \
    SHRestricted, N, <NONE>,  'SHRestricted',  \
    SHRunControlPanel, N, <NONE>,  'SHRunControlPanel',  \
    SHSetInstanceExplorer, N, <NONE>,  'SHSetInstanceExplorer',  \
    SHSetLocalizedName, N, <NONE>,  'SHSetLocalizedName',  \
    SHSetUnreadMailCount, W, <NONE>,  'SHSetUnreadMailCountW',  \
    SHShellFolderView_Message, N, <NONE>,  'SHShellFolderView_Message',  \
    SHSimpleIDListFromPath, N, <NONE>,  'SHSimpleIDListFromPath',  \
    SHStartNetConnectionDialog, W, <NONE>,  'SHStartNetConnectionDialogW',  \
    SHTestTokenMembership, N, <NONE>,  'SHTestTokenMembership',  \
    SHUnlockShared, N, <NONE>,  'SHUnlockShared',  \
    SHUpdateImage, A, <NONE>,  'SHUpdateImageA',  \
    SHUpdateImage, W, <NONE>,  'SHUpdateImageW',  \
    SHUpdateRecycleBinIcon, N, <NONE>,  'SHUpdateRecycleBinIcon',  \
    SHValidateUNC, N, <NONE>,  'SHValidateUNC',  \
    SheChangeDir, A, <NONE>,  'SheChangeDirA',  \
    SheChangeDirEx, A, <NONE>,  'SheChangeDirExA',  \
    SheChangeDirEx, W, <NONE>,  'SheChangeDirExW',  \
    SheChangeDir, W, <NONE>,  'SheChangeDirW',  \
    SheConvertPath, W, <NONE>,  'SheConvertPathW',  \
    SheFullPath, A, <NONE>,  'SheFullPathA',  \
    SheFullPath, W, <NONE>,  'SheFullPathW',  \
    SheGetCurDrive, N, <NONE>,  'SheGetCurDrive',  \
    SheGetDir, A, <NONE>,  'SheGetDirA',  \
    SheGetDirEx, W, <NONE>,  'SheGetDirExW',  \
    SheGetDir, W, <NONE>,  'SheGetDirW',  \
    SheGetPathOffset, W, <NONE>,  'SheGetPathOffsetW',  \
    SheRemoveQuotes, A, <NONE>,  'SheRemoveQuotesA',  \
    SheRemoveQuotes, W, <NONE>,  'SheRemoveQuotesW',  \
    SheSetCurDrive, N, <NONE>,  'SheSetCurDrive',  \
    SheShortenPath, A, <NONE>,  'SheShortenPathA',  \
    SheShortenPath, W, <NONE>,  'SheShortenPathW',  \
    ShellAbout, A, <.hwnd, .szApp, .szOtherStuff, .hIcon>,  'ShellAboutA',  \
    ShellAbout, W, <.hwnd, .szApp, .szOtherStuff, .hIcon>,  'ShellAboutW',  \
    ShellExec_RunDLL, A, <NONE>,  'ShellExec_RunDLLA',  \
    ShellExec_RunDLL, W, <NONE>,  'ShellExec_RunDLLW',  \
    ShellExecute, A, <.hwnd, .lpOperation, .lpFile, .lpParameters, .lpDirectory, .nCmdShow>,  'ShellExecuteA',  \
    ShellExecuteEx, A, <.lpExecInfo>,  'ShellExecuteExA',  \
    ShellExecuteEx, W, <.lpExecInfo>,  'ShellExecuteExW',  \
    ShellExecute, W, <.hwnd, .lpOperation, .lpFile, .lpParameters, .lpDirectory, .nCmdShow>,  'ShellExecuteW',  \
    ShellHookProc, N, <NONE>,  'ShellHookProc',  \
    ShellMessageBox, A, <NONE>,  'ShellMessageBoxA',  \
    ShellMessageBox, W, <NONE>,  'ShellMessageBoxW',  \
    Shell_GetCachedImageIndex, N, <NONE>,  'Shell_GetCachedImageIndex',  \
    Shell_GetImageLists, N, <NONE>,  'Shell_GetImageLists',  \
    Shell_MergeMenus, N, <NONE>,  'Shell_MergeMenus',  \
    Shell_NotifyIcon, A, <.dwMessage, .lpData>,  'Shell_NotifyIconA',  \
    Shell_NotifyIcon, W, <.dwMessage, .lpData>,  'Shell_NotifyIconW',  \
    SignalFileOpen, N, <NONE>,  'SignalFileOpen',  \
    StrChr, A, <.lpStart, .wMatch>,  'StrChrA',  \
    StrChrI, A, <.lpStart, .wMatch>,  'StrChrIA',  \
    StrChrI, W, <.lpStart, .wMatch>,  'StrChrIW',  \
    StrChr, W, <.lpStart, .wMatch>,  'StrChrW',  \
    StrCmpN, A, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNA',  \
    StrCmpNI, A, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNIA',  \
    StrCmpNI, W, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNIW',  \
    StrCmpN, W, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNW',  \
    StrCpyN, A, <NONE>,  'StrCpyNA',  \
    StrCpyN, W, <NONE>,  'StrCpyNW',  \
    StrNCmp, A, <NONE>,  'StrNCmpA',  \
    StrNCmpI, A, <NONE>,  'StrNCmpIA',  \
    StrNCmpI, W, <NONE>,  'StrNCmpIW',  \
    StrNCmp, W, <NONE>,  'StrNCmpW',  \
    StrNCpy, A, <NONE>,  'StrNCpyA',  \
    StrNCpy, W, <NONE>,  'StrNCpyW',  \
    StrRChr, A, <.lpStart, .lpEnd, .wMatch>,  'StrRChrA',  \
    StrRChrI, A, <.lpStart, .lpEnd, .wMatch>,  'StrRChrIA',  \
    StrRChrI, W, <.lpStart, .lpEnd, .wMatch>,  'StrRChrIW',  \
    StrRChr, W, <.lpStart, .lpEnd, .wMatch>,  'StrRChrW',  \
    StrRStr, A, <NONE>,  'StrRStrA',  \
    StrRStrI, A, <.lpSource, .lpLast, .lpSrch>,  'StrRStrIA',  \
    StrRStrI, W, <.lpSource, .lpLast, .lpSrch>,  'StrRStrIW',  \
    StrRStr, W, <NONE>,  'StrRStrW',  \
    StrStr, A, <.lpFirst, .lpSrch>,  'StrStrA',  \
    StrStrI, A, <.lpFirst, .lpSrch>,  'StrStrIA',  \
    StrStrI, W, <.lpFirst, .lpSrch>,  'StrStrIW',  \
    StrStr, W, <.lpFirst, .lpSrch>,  'StrStrW',  \
    WOWShellExecute, N, <NONE>,  'WOWShellExecute',  \
    Win32DeleteFile, N, <NONE>,  'Win32DeleteFile',  \
    WriteCabinetState, N, <NONE>,  'WriteCabinetState'
